<?php

/**
 * planifica_fp actions.
 *
 * @package    cobro_coactivo
 * @subpackage planifica_fp
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class planifica_fpActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_PLANIFICA_FP_V',
        'CBR_FACILIDAD_PAGO_V',
        'CBR_PROCESO_COACTIVO',
        'CBR_AVOCA_CONOC',
        'CBR_REMISION_TITULO',
        'CBR_TITULO_MINERO_V',
        'CBR_ACTUALIZA_TITULO_V',
        'CBR_TIPO_DOCUMENTO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_FACILIDAD_PAGO_V' =>
        array(
            'id_facilidad_pago' => 'CBR_PLANIFICA_FP_V'
        ),
        'CBR_PROCESO_COACTIVO,LEFT' =>
        array(
            'id_proceso_coactivo' => 'CBR_FACILIDAD_PAGO_V'
        ),
        'CBR_AVOCA_CONOC,LEFT' =>
        array(
            'id_avoca_conoc' => 'CBR_FACILIDAD_PAGO_V'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo' => 'CBR_FACILIDAD_PAGO_V'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_ACTUALIZA_TITULO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_TIPO_DOCUMENTO,LEFT' =>
        array(
            'id_tipo_documento' => 'CBR_AVOCA_CONOC'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_PLANIFICA_FP_V' =>
        array(
            'id_planifica_fp' => 'id_planifica_fp',
            'id_facilidad_pago' => 'id_facilidad_pago',
            'fecha_inicio' => 'fecha_inicio',
            'valor_total' => 'valor_total',
            'numero_cuotas' => 'numero_cuotas',
            'id_tasa_interes_corriente' => 'id_tasa_interes_corriente',
            'id_tasa_interes_mora' => 'id_tasa_interes_mora',
            'descripcion' => 'descripcion',
            'interes_mora' => 'interes_mora',
            'interes_corriente' => 'interes_corriente',
            'valor_interes_mora' => 'valor_interes_mora',
            'valor_interes_corriente' => 'valor_interes_corriente',
            'adjunto' => 'adjunto'
        ),
        'CBR_FACILIDAD_PAGO_V' =>
        array(
            'id_remision_titulo' => 'id_remision_titulo',
            'id_proceso_coactivo' => 'id_proceso_coactivo',
            'id_avoca_conoc' => 'id_avoca_conoc',
            'fecha_registro' => 'fecha_registro'
        ),
        'CBR_PROCESO_COACTIVO' =>
        array(
            'no_proceso' => 'no_proceso',
            'fecha' => 'fecha_coactivo'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'fecha_remision' => 'fecha_remision',
            'estado' => 'estado',
            'cod_titulo' => 'cod_titulo',
            'anho_remision' => 'id_anhos'
        ),
        'CBR_AVOCA_CONOC' =>
        array(
            'no_auto' => 'no_auto',
            'fecha' => 'fecha_avoca',
            'id_tipo_documento' => 'id_tipo_documento'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral_deb',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral_deb'
        ),
        'CBR_ACTUALIZA_TITULO_V' =>
        array(
            'mineral' => 'mineral',
            'id_mineral' => 'id_mineral',
            'cod_mineral' => 'cod_mineral'
        ),
        'CBR_TIPO_DOCUMENTO' =>
        array(
            'descripcion' => 'descripcion_tipdoc'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'fecha_inicio', 'id_anhos', 'cod_titulo', 'id_planifica_fp'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_PLANIFICA_FP_V' =>
        array(
            'id_planifica_fp,a' => array('!=' => array(-1)),
            'id_planifica_fp,b' => array('=' => array('id_planifica_fp')),
            'fecha_inicio' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'id_facilidad_pago' => array('=' => array('id_facilidad_pago')),
            'id_tasa_interes_corriente' => array('=' => array('id_tasa_interes_corriente')),
            'id_tasa_interes_mora' => array('=' => array('id_tasa_interes_mora')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CBR_PROCESO_COACTIVO' =>
        array(
            'id_anhos' => array('=' => array('no_proceso'))
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'cod_titulo' => array('=' => array('cod_titulo')),
            'anho_remision' => array('=' => array('id_anhos'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_planifica_fp'; //identificador de la tabla
    protected $id_names = array('id_planifica_fp'); //llave primaria
    protected $field_names = array('id_facilidad_pago', 'fecha_inicio', 'valor_total', 'numero_cuotas',
        'id_tasa_interes_corriente', 'id_tasa_interes_mora', 'descripcion', 'usuario_log', 'adjunto'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_PLANIFICA_FP'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_planifica_fp'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {

                $id_planifica_fp = $list_data_post[0]['id_planifica_fp'];
                $numero_cuotas = $list_data_post[0]['numero_cuotas'];
                $fecha_inicio = $list_data_post[0]['fecha_inicio'];
                $valor_total = $list_data_post[0]['valor_total'];
                $id_tasa_interes_corriente = $list_data_post[0]['id_tasa_interes_corriente'];
                $valor_total_t = $valor_total;
                $sql = <<<EOD
select tab0.* from ca_tasa_interes tab0 where id_tasa_interes = $id_tasa_interes_corriente
EOD;

                $records = CN_TABLE::executeSQL($sql);

                $porcentaje_interes = $records[0]['valor'];



                $valor_cuota = round($valor_total / $numero_cuotas, 0);

                //$valor_int_corri = $valor_cuota * 0.3 / 100; //CALCULO TEMPORAL MIENTRAS SE DEFINE LA FORMULA
                //Actualización: 13 de Noviembre de 2015
                //Formula tasa de interes corriente
                // IC = K x (TU/366) x 30
                // K = Capital 
                // TU = Tasa de Interes


                for ($i = 0; $i < $numero_cuotas; $i++) {


                    $numero_cuota = $i + 1;

                    //$valor_int_corri = $valor_total_t * (($porcentaje_interes / 100) / 366) * 30;
                    //Nuevo calculo ((pow((1+ ($tasa/100) ),($dias/365))-1) * $valor_deuda ) - 20170706
                    $valor_int_corri = (pow((1 + ($porcentaje_interes / 100)), (30 / 365)) - 1) * $valor_total_t;
                    $valor_int_corri = round($valor_int_corri, 0);

                    $valor_total_cuota = $valor_cuota + $valor_int_corri;


                    $sql = <<<EOD
INSERT INTO CBR_DETALLE_CUOTA (ID_PLANIFICA_FP,NUMERO_CUOTA,FECHA_CUOTA,
    VALOR_CUOTA,VALOR_INT_CORRI,VALOR_TOTAL,FECHA_CUOTA_HABIL)
VALUES($id_planifica_fp,$numero_cuota,ADD_MONTHS(to_date('$fecha_inicio','YYYY-MM-DD'), '$i'), 
        $valor_cuota,$valor_int_corri,$valor_total_cuota, DIAS_HABILES( (ADD_MONTHS(to_date('$fecha_inicio','YYYY-MM-DD'), '$i'))-1 ,1) )
EOD;

                    $this->conn->execute($sql);

                    $valor_total_t = $valor_total_t - $valor_cuota;
                }

                //COMMIT
                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            //Campos de log - 20200221
            $request['usuario_log'] = $request['id_username'];
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
